# gettext.py
#-----------------------------------------------------------
# Python script which creates a function "gettext(filename)"
# that reads an ASCII file and turns the contents into a
# text label.
# Execute this script using menu option "File/Execute Script",
# if Python has been compiled in.
#
# Also:  defines a function which can be called with a key
# macro (gets the filename via popup prompt) and binds it
# to key "^G" (ctrl-"g"), and defines a button named "Get Text"
# under the "Edit" menu which does the same.
#-----------------------------------------------------------

def newlabel(x, y, l):
   h1=newelement("Label")
   d = {"scale": 1.0, "rotation": 0, "justify": 0, "pin": 0,
	"position": (x, y), "string": l}
   setattr(h1, d)
   return h1

def gettext(f, lpp=66, font='Courier'):
   import string
   cpage = page()
   npage = cpage
   ls=[]
   lines=0
   try:
      fi = open(f, 'r')
   except IOError:
      return
   else:
      T = getcursor();
      D = {'Font': font}
      S2 = [D]
      S = fi.readlines()
      for X in S:
	 lines = lines + 1
	 Y = X
	 nl = string.find(Y, '\012')
	 if nl <> -1:
	    Y = Y[0:nl]
	 while 1:
	    tb = string.find(Y, '\011')
	    if tb == -1:
	       break
	    else:
	       Z = Y[tb + 1:]
	       Y = Y[0:tb]
	       D = {'Text': Y}
	       S2.append(D)
	       S2.append('Tab Forward')
	       Y = Z
	 while 1:
	    ff = string.find(Y, '\014')
	    if ff == -1:
	       break
	    else:
	       Z = Y[ff + 1:]
	       Y = Y[0:ff]
	       D = {'Text': Y}
	       S2.append(D)
	       h1 = newlabel(T[0], T[1], S2)
	       npage = npage + 1
	       page(npage)
	       ls.append(h1)
	       D = {'Font': font}
	       S2 = [D]
	       lines = 0
	       Y = Z
	 D = {'Text': Y}
         S2.append(D)
	 if lpp > 0 and lines >= lpp:
	    h1 = newlabel(T[0], T[1], S2)
	    npage = npage + 1
	    page(npage)
	    ls.append(h1)
	    D = {'Font': font}
	    S2 = [D]
	    lines = 0
	 elif nl <> -1:
	    S2.append('Return')
      h1 = newlabel(T[0], T[1], S2)
      if ls <> []:
	 ls.append(h1)
	 page(cpage)
	 return ls
      else:
	 return h1

def prompttext():
   filepopup('Enter filename to import:', 'gettext')

bind('Control_G', 'prompttext')
newbutton('Edit', 'Get Text (^G)', 'prompttext')

#-----------------------------------------------------------
